﻿using System;
using System.CodeDom;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ProgramTree;

namespace SimpleLang.Visitors
{
    public class CommonlyUsedVarVisitor : AutoVisitor
    {
        private Dictionary<string, int> vars = new Dictionary<string, int>();

        public override void VisitIdNode(IdNode id)
        {
            if (vars.ContainsKey(id.Name))
            {
                vars[id.Name]++;
            }
            else
            {
                vars[id.Name] = 1;
            }
        }

        public string mostCommonlyUsedVar()
        {
            KeyValuePair<string, int> max = new KeyValuePair<string, int>("No variables :(", 0);
            foreach (var entry in vars)
            {
                if (entry.Value > max.Value)
                {
                    max = entry;
                }
            }

            return max.Key;
        }
    }
}
