﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ProgramTree;

namespace SimpleLang.Visitors
{
    public class CountCyclesOpVisitor : AutoVisitor
    {
        private List<int> cycleCounts = new List<int>();
        private int currentIndex = -1;
        public int MidCount()
        {
            return cycleCounts.Count == 0 ? 0 : (int)cycleCounts.Average();
        }

        public override void VisitAssignNode(AssignNode a)
        {
            if (cycleCounts.Count > 0)
            {
                cycleCounts[currentIndex]++;
            }
            a.Id.Visit(this);
            a.Expr.Visit(this);
        }

        public override void VisitCycleNode(CycleNode c)
        {
            c.Expr.Visit(this);
            cycleCounts.Add(0);
            currentIndex++;
            c.Stat.Visit(this);
            currentIndex--;
        }
    }
}
