﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ProgramTree;

namespace SimpleLang.Visitors
{
    public class MaxNestCyclesVisitor : AutoVisitor
    {
        public int MaxNest = 0;
        private int currentNest = 0;
        private bool isFirstLayer = true;
        private bool isCycleDeepening = false;

        public override void VisitCycleNode(CycleNode c)
        {
            if (!isFirstLayer)
            {
                if (isCycleDeepening)
                {
                    currentNest++;
                    isCycleDeepening = false;
                }
                c.Expr.Visit(this);
                isCycleDeepening = true;
                c.Stat.Visit(this);
                isCycleDeepening = false;
                return;
            }
            isFirstLayer = false;
            currentNest = 1;
            c.Expr.Visit(this);
            isCycleDeepening = true;
            c.Stat.Visit(this);
            isFirstLayer = true;
            if (currentNest > MaxNest)
            {
                MaxNest = currentNest;
            }
        }
    }
}
